/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// ReportField struct for ReportField
type ReportField struct {
	// The protocol the address relates to
	Protocol string `json:"protocol"`
	// The wallet/account the transaction occurred
	Address string `json:"address"`
	// The currency symbol
	Currency string `json:"currency"`
	// The ID of the event within a transaction
	EventId string `json:"event_id"`
	// The block number the transaction occurred on
	Block int64 `json:"block"`
	// The unix timestamp when the transaction was added to a block
	Timestamp int32 `json:"timestamp"`
	// The transaction ID
	Hash string `json:"hash"`
	// The action type e.g. Transfer, Deposit, Staking Reward etc..
	Action string `json:"action"`
	// The amount of currency involved in the transaction (smallest unit)
	Value string `json:"value"`
	// The address where the funds originated
	SenderAddress string `json:"sender_address"`
	// How much was charged as a fee for processing the transaction
	Fee string `json:"fee"`
	// The number of decimals in one coin, used to convert smallest unit to 1 whole coin if needed
	Decimals int32            `json:"decimals"`
	Meta     *ReportFieldMeta `json:"meta,omitempty"`
}

// NewReportField instantiates a new ReportField object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewReportField(protocol string, address string, currency string, eventId string, block int64, timestamp int32, hash string, action string, value string, senderAddress string, fee string, decimals int32) *ReportField {
	this := ReportField{}
	this.Protocol = protocol
	this.Address = address
	this.Currency = currency
	this.EventId = eventId
	this.Block = block
	this.Timestamp = timestamp
	this.Hash = hash
	this.Action = action
	this.Value = value
	this.SenderAddress = senderAddress
	this.Fee = fee
	this.Decimals = decimals
	return &this
}

// NewReportFieldWithDefaults instantiates a new ReportField object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewReportFieldWithDefaults() *ReportField {
	this := ReportField{}
	return &this
}

// GetProtocol returns the Protocol field value
func (o *ReportField) GetProtocol() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Protocol
}

// GetProtocolOk returns a tuple with the Protocol field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetProtocolOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Protocol, true
}

// SetProtocol sets field value
func (o *ReportField) SetProtocol(v string) {
	o.Protocol = v
}

// GetAddress returns the Address field value
func (o *ReportField) GetAddress() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Address
}

// GetAddressOk returns a tuple with the Address field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetAddressOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Address, true
}

// SetAddress sets field value
func (o *ReportField) SetAddress(v string) {
	o.Address = v
}

// GetCurrency returns the Currency field value
func (o *ReportField) GetCurrency() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetCurrencyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Currency, true
}

// SetCurrency sets field value
func (o *ReportField) SetCurrency(v string) {
	o.Currency = v
}

// GetEventId returns the EventId field value
func (o *ReportField) GetEventId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.EventId
}

// GetEventIdOk returns a tuple with the EventId field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetEventIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.EventId, true
}

// SetEventId sets field value
func (o *ReportField) SetEventId(v string) {
	o.EventId = v
}

// GetBlock returns the Block field value
func (o *ReportField) GetBlock() int64 {
	if o == nil {
		var ret int64
		return ret
	}

	return o.Block
}

// GetBlockOk returns a tuple with the Block field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetBlockOk() (*int64, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Block, true
}

// SetBlock sets field value
func (o *ReportField) SetBlock(v int64) {
	o.Block = v
}

// GetTimestamp returns the Timestamp field value
func (o *ReportField) GetTimestamp() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetTimestampOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Timestamp, true
}

// SetTimestamp sets field value
func (o *ReportField) SetTimestamp(v int32) {
	o.Timestamp = v
}

// GetHash returns the Hash field value
func (o *ReportField) GetHash() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Hash
}

// GetHashOk returns a tuple with the Hash field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetHashOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Hash, true
}

// SetHash sets field value
func (o *ReportField) SetHash(v string) {
	o.Hash = v
}

// GetAction returns the Action field value
func (o *ReportField) GetAction() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Action
}

// GetActionOk returns a tuple with the Action field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetActionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Action, true
}

// SetAction sets field value
func (o *ReportField) SetAction(v string) {
	o.Action = v
}

// GetValue returns the Value field value
func (o *ReportField) GetValue() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetValueOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *ReportField) SetValue(v string) {
	o.Value = v
}

// GetSenderAddress returns the SenderAddress field value
func (o *ReportField) GetSenderAddress() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SenderAddress
}

// GetSenderAddressOk returns a tuple with the SenderAddress field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetSenderAddressOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SenderAddress, true
}

// SetSenderAddress sets field value
func (o *ReportField) SetSenderAddress(v string) {
	o.SenderAddress = v
}

// GetFee returns the Fee field value
func (o *ReportField) GetFee() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Fee
}

// GetFeeOk returns a tuple with the Fee field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetFeeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Fee, true
}

// SetFee sets field value
func (o *ReportField) SetFee(v string) {
	o.Fee = v
}

// GetDecimals returns the Decimals field value
func (o *ReportField) GetDecimals() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Decimals
}

// GetDecimalsOk returns a tuple with the Decimals field value
// and a boolean to check if the value has been set.
func (o *ReportField) GetDecimalsOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Decimals, true
}

// SetDecimals sets field value
func (o *ReportField) SetDecimals(v int32) {
	o.Decimals = v
}

// GetMeta returns the Meta field value if set, zero value otherwise.
func (o *ReportField) GetMeta() ReportFieldMeta {
	if o == nil || o.Meta == nil {
		var ret ReportFieldMeta
		return ret
	}
	return *o.Meta
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ReportField) GetMetaOk() (*ReportFieldMeta, bool) {
	if o == nil || o.Meta == nil {
		return nil, false
	}
	return o.Meta, true
}

// HasMeta returns a boolean if a field has been set.
func (o *ReportField) HasMeta() bool {
	if o != nil && o.Meta != nil {
		return true
	}

	return false
}

// SetMeta gets a reference to the given ReportFieldMeta and assigns it to the Meta field.
func (o *ReportField) SetMeta(v ReportFieldMeta) {
	o.Meta = &v
}

func (o ReportField) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if true {
		toSerialize["protocol"] = o.Protocol
	}
	if true {
		toSerialize["address"] = o.Address
	}
	if true {
		toSerialize["currency"] = o.Currency
	}
	if true {
		toSerialize["event_id"] = o.EventId
	}
	if true {
		toSerialize["block"] = o.Block
	}
	if true {
		toSerialize["timestamp"] = o.Timestamp
	}
	if true {
		toSerialize["hash"] = o.Hash
	}
	if true {
		toSerialize["action"] = o.Action
	}
	if true {
		toSerialize["value"] = o.Value
	}
	if true {
		toSerialize["sender_address"] = o.SenderAddress
	}
	if true {
		toSerialize["fee"] = o.Fee
	}
	if true {
		toSerialize["decimals"] = o.Decimals
	}
	if o.Meta != nil {
		toSerialize["meta"] = o.Meta
	}
	return json.Marshal(toSerialize)
}

type NullableReportField struct {
	value *ReportField
	isSet bool
}

func (v NullableReportField) Get() *ReportField {
	return v.value
}

func (v *NullableReportField) Set(val *ReportField) {
	v.value = val
	v.isSet = true
}

func (v NullableReportField) IsSet() bool {
	return v.isSet
}

func (v *NullableReportField) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableReportField(val *ReportField) *NullableReportField {
	return &NullableReportField{value: val, isSet: true}
}

func (v NullableReportField) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableReportField) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
